
/* ------------------------------------------------------------
   This is the file "solver.h" of the HLib package.

   Copyright 1999 Lars Grasedyck and Steffen Boerm
   Max-Planck-Institut fuer Mathematik in den Naturwissenschaften
   Inselstrasse 22-26
   04103 Leipzig
   http://www.mis.mpg.de
   ------------------------------------------------------------ */

#ifndef Solver
#define Solver

#include "basic.h"
#include "supermatrix.h"

#include <stdlib.h>

double* 
solvecg_supermatrix(psupermatrix s, double* rhs, double eps);

double* 
solvecgkaczmarz_supermatrix(psupermatrix s, double* rhs, double eps);

double* 
solvepreconditionedcg_supermatrix(psupermatrix s, psupermatrix winv, double* rhs);

double* 
solvecholeskypreconditionedcg_supermatrix(psparsematrix s, psupermatrix l, double* rhs, double eps);

double* 
solvecholeskypreconditionedcg2_supermatrix(psupermatrix s, psupermatrix l, double* rhs, double eps);

double* 
solvelupreconditionedcg2_supermatrix(psupermatrix s, psupermatrix l, double* rhs, double eps);
double* 
solvelupreconditionedcg3_supermatrix(psupermatrix s, prkmatrix rk, 
				     psupermatrix l, double* rhs,
				     double eps);

#endif
